// envelopefun.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/


// this maps an Envelope over the amplitudes of the data [f(x) = f(env, x)]

#ifndef ENVELOPE_FUN_H
#ifdef __GNUG__
#pragma interface
#endif
#define ENVELOPE_FUN_H

#include "processfun.h"

class Envelope;

class EnvelopeFunction : public SimpleFunction {
public:
	EnvelopeFunction(Data* output, Envelope *evp);
	virtual ~EnvelopeFunction();
	redefined void restoreState();
protected:
	Envelope *envelope;
};

#endif

